Index: lemon/core.h
===================================================================
--- lemon/core.h	(revision 327)
+++ lemon/core.h	(revision 220)
@@ -25,12 +25,7 @@
 #include <lemon/bits/enable_if.h>
 #include <lemon/bits/traits.h>
-#include <lemon/assert.h>
 
 ///\file
 ///\brief LEMON core utilities.
-///
-///This header file contains core utilities for LEMON.
-///It is automatically included by all graph types, therefore it usually
-///do not have to be included directly.
 
 namespace lemon {
@@ -60,8 +55,8 @@
   /// @{
 
-  ///Create convenience typedefs for the digraph types and iterators
-
-  ///This \c \#define creates convenient type definitions for the following
-  ///types of \c Digraph: \c Node,  \c NodeIt, \c Arc, \c ArcIt, \c InArcIt,
+  ///Creates convenience typedefs for the digraph types and iterators
+
+  ///This \c \#define creates convenience typedefs for the following types
+  ///of \c Digraph: \c Node,  \c NodeIt, \c Arc, \c ArcIt, \c InArcIt,
   ///\c OutArcIt, \c BoolNodeMap, \c IntNodeMap, \c DoubleNodeMap,
   ///\c BoolArcMap, \c IntArcMap, \c DoubleArcMap.
@@ -84,5 +79,5 @@
   typedef Digraph::ArcMap<double> DoubleArcMap
 
-  ///Create convenience typedefs for the digraph types and iterators
+  ///Creates convenience typedefs for the digraph types and iterators
 
   ///\see DIGRAPH_TYPEDEFS
@@ -104,7 +99,7 @@
   typedef typename Digraph::template ArcMap<double> DoubleArcMap
 
-  ///Create convenience typedefs for the graph types and iterators
-
-  ///This \c \#define creates the same convenient type definitions as defined
+  ///Creates convenience typedefs for the graph types and iterators
+
+  ///This \c \#define creates the same convenience typedefs as defined
   ///by \ref DIGRAPH_TYPEDEFS(Graph) and six more, namely it creates
   ///\c Edge, \c EdgeIt, \c IncEdgeIt, \c BoolEdgeMap, \c IntEdgeMap,
@@ -112,5 +107,5 @@
   ///
   ///\note If the graph type is a dependent type, ie. the graph type depend
-  ///on a template parameter, then use \c TEMPLATE_GRAPH_TYPEDEFS()
+  ///on a template parameter, then use \c TEMPLATE_DIGRAPH_TYPEDEFS()
   ///macro.
 #define GRAPH_TYPEDEFS(Graph)                                           \
@@ -123,5 +118,5 @@
   typedef Graph::EdgeMap<double> DoubleEdgeMap
 
-  ///Create convenience typedefs for the graph types and iterators
+  ///Creates convenience typedefs for the graph types and iterators
 
   ///\see GRAPH_TYPEDEFS
@@ -138,8 +133,8 @@
   typedef typename Graph::template EdgeMap<double> DoubleEdgeMap
 
-  /// \brief Function to count the items in a graph.
-  ///
-  /// This function counts the items (nodes, arcs etc.) in a graph.
-  /// The complexity of the function is linear because
+  /// \brief Function to count the items in the graph.
+  ///
+  /// This function counts the items (nodes, arcs etc) in the graph.
+  /// The complexity of the function is O(n) because
   /// it iterates on all of the items.
   template <typename Graph, typename Item>
@@ -178,9 +173,9 @@
   ///
   /// This function counts the nodes in the graph.
-  /// The complexity of the function is <em>O</em>(<em>n</em>), but for some
-  /// graph structures it is specialized to run in <em>O</em>(1).
-  ///
-  /// \note If the graph contains a \c nodeNum() member function and a
-  /// \c NodeNumTag tag then this function calls directly the member
+  /// The complexity of the function is O(n) but for some
+  /// graph structures it is specialized to run in O(1).
+  ///
+  /// If the graph contains a \e nodeNum() member function and a
+  /// \e NodeNumTag tag then this function calls directly the member
   /// function to query the cardinality of the node set.
   template <typename Graph>
@@ -214,9 +209,9 @@
   ///
   /// This function counts the arcs in the graph.
-  /// The complexity of the function is <em>O</em>(<em>m</em>), but for some
-  /// graph structures it is specialized to run in <em>O</em>(1).
-  ///
-  /// \note If the graph contains a \c arcNum() member function and a
-  /// \c ArcNumTag tag then this function calls directly the member
+  /// The complexity of the function is O(e) but for some
+  /// graph structures it is specialized to run in O(1).
+  ///
+  /// If the graph contains a \e arcNum() member function and a
+  /// \e EdgeNumTag tag then this function calls directly the member
   /// function to query the cardinality of the arc set.
   template <typename Graph>
@@ -226,5 +221,4 @@
 
   // Edge counting:
-
   namespace _core_bits {
 
@@ -250,9 +244,9 @@
   ///
   /// This function counts the edges in the graph.
-  /// The complexity of the function is <em>O</em>(<em>m</em>), but for some
-  /// graph structures it is specialized to run in <em>O</em>(1).
-  ///
-  /// \note If the graph contains a \c edgeNum() member function and a
-  /// \c EdgeNumTag tag then this function calls directly the member
+  /// The complexity of the function is O(m) but for some
+  /// graph structures it is specialized to run in O(1).
+  ///
+  /// If the graph contains a \e edgeNum() member function and a
+  /// \e EdgeNumTag tag then this function calls directly the member
   /// function to query the cardinality of the edge set.
   template <typename Graph>
@@ -275,8 +269,8 @@
   ///
   /// This function counts the number of the out-arcs from node \c n
-  /// in the graph \c g.
+  /// in the graph.
   template <typename Graph>
-  inline int countOutArcs(const Graph& g,  const typename Graph::Node& n) {
-    return countNodeDegree<Graph, typename Graph::OutArcIt>(g, n);
+  inline int countOutArcs(const Graph& _g,  const typename Graph::Node& _n) {
+    return countNodeDegree<Graph, typename Graph::OutArcIt>(_g, _n);
   }
 
@@ -284,8 +278,8 @@
   ///
   /// This function counts the number of the in-arcs to node \c n
-  /// in the graph \c g.
+  /// in the graph.
   template <typename Graph>
-  inline int countInArcs(const Graph& g,  const typename Graph::Node& n) {
-    return countNodeDegree<Graph, typename Graph::InArcIt>(g, n);
+  inline int countInArcs(const Graph& _g,  const typename Graph::Node& _n) {
+    return countNodeDegree<Graph, typename Graph::InArcIt>(_g, _n);
   }
 
@@ -293,8 +287,8 @@
   ///
   /// This function counts the number of the inc-edges to node \c n
-  /// in the undirected graph \c g.
+  /// in the graph.
   template <typename Graph>
-  inline int countIncEdges(const Graph& g,  const typename Graph::Node& n) {
-    return countNodeDegree<Graph, typename Graph::IncEdgeIt>(g, n);
+  inline int countIncEdges(const Graph& _g,  const typename Graph::Node& _n) {
+    return countNodeDegree<Graph, typename Graph::IncEdgeIt>(_g, _n);
   }
 
@@ -310,10 +304,10 @@
 
     template <typename Digraph, typename Item, typename RefMap,
-              typename FromMap, typename ToMap>
+              typename ToMap, typename FromMap>
     class MapCopy : public MapCopyBase<Digraph, Item, RefMap> {
     public:
 
-      MapCopy(const FromMap& map, ToMap& tmap)
-        : _map(map), _tmap(tmap) {}
+      MapCopy(ToMap& tmap, const FromMap& map)
+        : _tmap(tmap), _map(map) {}
 
       virtual void copy(const Digraph& digraph, const RefMap& refMap) {
@@ -325,6 +319,6 @@
 
     private:
+      ToMap& _tmap;
       const FromMap& _map;
-      ToMap& _tmap;
     };
 
@@ -333,5 +327,5 @@
     public:
 
-      ItemCopy(const Item& item, It& it) : _item(item), _it(it) {}
+      ItemCopy(It& it, const Item& item) : _it(it), _item(item) {}
 
       virtual void copy(const Digraph&, const RefMap& refMap) {
@@ -340,6 +334,6 @@
 
     private:
+      It& _it;
       Item _item;
-      It& _it;
     };
 
@@ -382,5 +376,5 @@
     struct DigraphCopySelector {
       template <typename From, typename NodeRefMap, typename ArcRefMap>
-      static void copy(const From& from, Digraph &to,
+      static void copy(Digraph &to, const From& from,
                        NodeRefMap& nodeRefMap, ArcRefMap& arcRefMap) {
         for (typename From::NodeIt it(from); it != INVALID; ++it) {
@@ -400,5 +394,5 @@
     {
       template <typename From, typename NodeRefMap, typename ArcRefMap>
-      static void copy(const From& from, Digraph &to,
+      static void copy(Digraph &to, const From& from,
                        NodeRefMap& nodeRefMap, ArcRefMap& arcRefMap) {
         to.build(from, nodeRefMap, arcRefMap);
@@ -409,5 +403,5 @@
     struct GraphCopySelector {
       template <typename From, typename NodeRefMap, typename EdgeRefMap>
-      static void copy(const From& from, Graph &to,
+      static void copy(Graph &to, const From& from,
                        NodeRefMap& nodeRefMap, EdgeRefMap& edgeRefMap) {
         for (typename From::NodeIt it(from); it != INVALID; ++it) {
@@ -427,5 +421,5 @@
     {
       template <typename From, typename NodeRefMap, typename EdgeRefMap>
-      static void copy(const From& from, Graph &to,
+      static void copy(Graph &to, const From& from,
                        NodeRefMap& nodeRefMap, EdgeRefMap& edgeRefMap) {
         to.build(from, nodeRefMap, edgeRefMap);
@@ -438,37 +432,37 @@
   ///
   /// Class to copy a digraph to another digraph (duplicate a digraph). The
-  /// simplest way of using it is through the \c digraphCopy() function.
-  ///
-  /// This class not only make a copy of a digraph, but it can create
+  /// simplest way of using it is through the \c copyDigraph() function.
+  ///
+  /// This class not just make a copy of a graph, but it can create
   /// references and cross references between the nodes and arcs of
-  /// the two digraphs, and it can copy maps to use with the newly created
-  /// digraph.
-  ///
-  /// To make a copy from a digraph, first an instance of DigraphCopy
-  /// should be created, then the data belongs to the digraph should
+  /// the two graphs, it can copy maps for use with the newly created
+  /// graph and copy nodes and arcs.
+  ///
+  /// To make a copy from a graph, first an instance of DigraphCopy
+  /// should be created, then the data belongs to the graph should
   /// assigned to copy. In the end, the \c run() member should be
   /// called.
   ///
-  /// The next code copies a digraph with several data:
+  /// The next code copies a graph with several data:
   ///\code
-  ///  DigraphCopy<OrigGraph, NewGraph> cg(orig_graph, new_graph);
-  ///  // Create references for the nodes
+  ///  DigraphCopy<NewGraph, OrigGraph> dc(new_graph, orig_graph);
+  ///  // create a reference for the nodes
   ///  OrigGraph::NodeMap<NewGraph::Node> nr(orig_graph);
-  ///  cg.nodeRef(nr);
-  ///  // Create cross references (inverse) for the arcs
+  ///  dc.nodeRef(nr);
+  ///  // create a cross reference (inverse) for the arcs
   ///  NewGraph::ArcMap<OrigGraph::Arc> acr(new_graph);
-  ///  cg.arcCrossRef(acr);
-  ///  // Copy an arc map
+  ///  dc.arcCrossRef(acr);
+  ///  // copy an arc map
   ///  OrigGraph::ArcMap<double> oamap(orig_graph);
   ///  NewGraph::ArcMap<double> namap(new_graph);
-  ///  cg.arcMap(oamap, namap);
-  ///  // Copy a node
+  ///  dc.arcMap(namap, oamap);
+  ///  // copy a node
   ///  OrigGraph::Node on;
   ///  NewGraph::Node nn;
-  ///  cg.node(on, nn);
-  ///  // Execute copying
-  ///  cg.run();
+  ///  dc.node(nn, on);
+  ///  // Executions of copy
+  ///  dc.run();
   ///\endcode
-  template <typename From, typename To>
+  template <typename To, typename From>
   class DigraphCopy {
   private:
@@ -485,16 +479,18 @@
     typedef typename From::template ArcMap<TArc> ArcRefMap;
 
+
   public:
 
-    /// \brief Constructor of DigraphCopy.
-    ///
-    /// Constructor of DigraphCopy for copying the content of the
-    /// \c from digraph into the \c to digraph.
-    DigraphCopy(const From& from, To& to)
+
+    /// \brief Constructor for the DigraphCopy.
+    ///
+    /// It copies the content of the \c _from digraph into the
+    /// \c _to digraph.
+    DigraphCopy(To& to, const From& from)
       : _from(from), _to(to) {}
 
-    /// \brief Destructor of DigraphCopy
-    ///
-    /// Destructor of DigraphCopy.
+    /// \brief Destructor of the DigraphCopy
+    ///
+    /// Destructor of the DigraphCopy
     ~DigraphCopy() {
       for (int i = 0; i < int(_node_maps.size()); ++i) {
@@ -507,10 +503,10 @@
     }
 
-    /// \brief Copy the node references into the given map.
-    ///
-    /// This function copies the node references into the given map.
-    /// The parameter should be a map, whose key type is the Node type of
-    /// the source digraph, while the value type is the Node type of the
-    /// destination digraph.
+    /// \brief Copies the node references into the given map.
+    ///
+    /// Copies the node references into the given map. The parameter
+    /// should be a map, which key type is the Node type of the source
+    /// graph, while the value type is the Node type of the
+    /// destination graph.
     template <typename NodeRef>
     DigraphCopy& nodeRef(NodeRef& map) {
@@ -520,10 +516,10 @@
     }
 
-    /// \brief Copy the node cross references into the given map.
-    ///
-    /// This function copies the node cross references (reverse references)
-    /// into the given map. The parameter should be a map, whose key type
-    /// is the Node type of the destination digraph, while the value type is
-    /// the Node type of the source digraph.
+    /// \brief Copies the node cross references into the given map.
+    ///
+    ///  Copies the node cross references (reverse references) into
+    ///  the given map. The parameter should be a map, which key type
+    ///  is the Node type of the destination graph, while the value type is
+    ///  the Node type of the source graph.
     template <typename NodeCrossRef>
     DigraphCopy& nodeCrossRef(NodeCrossRef& map) {
@@ -533,15 +529,13 @@
     }
 
-    /// \brief Make a copy of the given node map.
-    ///
-    /// This function makes a copy of the given node map for the newly
-    /// created digraph.
-    /// The key type of the new map \c tmap should be the Node type of the
-    /// destination digraph, and the key type of the original map \c map
-    /// should be the Node type of the source digraph.
-    template <typename FromMap, typename ToMap>
-    DigraphCopy& nodeMap(const FromMap& map, ToMap& tmap) {
+    /// \brief Make copy of the given map.
+    ///
+    /// Makes copy of the given map for the newly created digraph.
+    /// The new map's key type is the destination graph's node type,
+    /// and the copied map's key type is the source graph's node type.
+    template <typename ToMap, typename FromMap>
+    DigraphCopy& nodeMap(ToMap& tmap, const FromMap& map) {
       _node_maps.push_back(new _core_bits::MapCopy<From, Node,
-                           NodeRefMap, FromMap, ToMap>(map, tmap));
+                           NodeRefMap, ToMap, FromMap>(tmap, map));
       return *this;
     }
@@ -549,17 +543,14 @@
     /// \brief Make a copy of the given node.
     ///
-    /// This function makes a copy of the given node.
-    DigraphCopy& node(const Node& node, TNode& tnode) {
+    /// Make a copy of the given node.
+    DigraphCopy& node(TNode& tnode, const Node& snode) {
       _node_maps.push_back(new _core_bits::ItemCopy<From, Node,
-                           NodeRefMap, TNode>(node, tnode));
-      return *this;
-    }
-
-    /// \brief Copy the arc references into the given map.
-    ///
-    /// This function copies the arc references into the given map.
-    /// The parameter should be a map, whose key type is the Arc type of
-    /// the source digraph, while the value type is the Arc type of the
-    /// destination digraph.
+                           NodeRefMap, TNode>(tnode, snode));
+      return *this;
+    }
+
+    /// \brief Copies the arc references into the given map.
+    ///
+    /// Copies the arc references into the given map.
     template <typename ArcRef>
     DigraphCopy& arcRef(ArcRef& map) {
@@ -569,10 +560,8 @@
     }
 
-    /// \brief Copy the arc cross references into the given map.
-    ///
-    /// This function copies the arc cross references (reverse references)
-    /// into the given map. The parameter should be a map, whose key type
-    /// is the Arc type of the destination digraph, while the value type is
-    /// the Arc type of the source digraph.
+    /// \brief Copies the arc cross references into the given map.
+    ///
+    ///  Copies the arc cross references (reverse references) into
+    ///  the given map.
     template <typename ArcCrossRef>
     DigraphCopy& arcCrossRef(ArcCrossRef& map) {
@@ -582,15 +571,14 @@
     }
 
-    /// \brief Make a copy of the given arc map.
-    ///
-    /// This function makes a copy of the given arc map for the newly
-    /// created digraph.
-    /// The key type of the new map \c tmap should be the Arc type of the
-    /// destination digraph, and the key type of the original map \c map
-    /// should be the Arc type of the source digraph.
-    template <typename FromMap, typename ToMap>
-    DigraphCopy& arcMap(const FromMap& map, ToMap& tmap) {
+    /// \brief Make copy of the given map.
+    ///
+    /// Makes copy of the given map for the newly created digraph.
+    /// The new map's key type is the to digraph's arc type,
+    /// and the copied map's key type is the from digraph's arc
+    /// type.
+    template <typename ToMap, typename FromMap>
+    DigraphCopy& arcMap(ToMap& tmap, const FromMap& map) {
       _arc_maps.push_back(new _core_bits::MapCopy<From, Arc,
-                          ArcRefMap, FromMap, ToMap>(map, tmap));
+                          ArcRefMap, ToMap, FromMap>(tmap, map));
       return *this;
     }
@@ -598,20 +586,19 @@
     /// \brief Make a copy of the given arc.
     ///
-    /// This function makes a copy of the given arc.
-    DigraphCopy& arc(const Arc& arc, TArc& tarc) {
+    /// Make a copy of the given arc.
+    DigraphCopy& arc(TArc& tarc, const Arc& sarc) {
       _arc_maps.push_back(new _core_bits::ItemCopy<From, Arc,
-                          ArcRefMap, TArc>(arc, tarc));
-      return *this;
-    }
-
-    /// \brief Execute copying.
-    ///
-    /// This function executes the copying of the digraph along with the
-    /// copying of the assigned data.
+                          ArcRefMap, TArc>(tarc, sarc));
+      return *this;
+    }
+
+    /// \brief Executes the copies.
+    ///
+    /// Executes the copies.
     void run() {
       NodeRefMap nodeRefMap(_from);
       ArcRefMap arcRefMap(_from);
       _core_bits::DigraphCopySelector<To>::
-        copy(_from, _to, nodeRefMap, arcRefMap);
+        copy(_to, _from, nodeRefMap, arcRefMap);
       for (int i = 0; i < int(_node_maps.size()); ++i) {
         _node_maps[i]->copy(_from, nodeRefMap);
@@ -624,12 +611,13 @@
   protected:
 
+
     const From& _from;
     To& _to;
 
     std::vector<_core_bits::MapCopyBase<From, Node, NodeRefMap>* >
-      _node_maps;
+    _node_maps;
 
     std::vector<_core_bits::MapCopyBase<From, Arc, ArcRefMap>* >
-      _arc_maps;
+    _arc_maps;
 
   };
@@ -637,20 +625,20 @@
   /// \brief Copy a digraph to another digraph.
   ///
-  /// This function copies a digraph to another digraph.
-  /// The complete usage of it is detailed in the DigraphCopy class, but
-  /// a short example shows a basic work:
+  /// Copy a digraph to another digraph. The complete usage of the
+  /// function is detailed in the DigraphCopy class, but a short
+  /// example shows a basic work:
   ///\code
-  /// digraphCopy(src, trg).nodeRef(nr).arcCrossRef(acr).run();
+  /// copyDigraph(trg, src).nodeRef(nr).arcCrossRef(ecr).run();
   ///\endcode
   ///
   /// After the copy the \c nr map will contain the mapping from the
   /// nodes of the \c from digraph to the nodes of the \c to digraph and
-  /// \c acr will contain the mapping from the arcs of the \c to digraph
+  /// \c ecr will contain the mapping from the arcs of the \c to digraph
   /// to the arcs of the \c from digraph.
   ///
   /// \see DigraphCopy
-  template <typename From, typename To>
-  DigraphCopy<From, To> digraphCopy(const From& from, To& to) {
-    return DigraphCopy<From, To>(from, to);
+  template <typename To, typename From>
+  DigraphCopy<To, From> copyDigraph(To& to, const From& from) {
+    return DigraphCopy<To, From>(to, from);
   }
 
@@ -658,10 +646,10 @@
   ///
   /// Class to copy a graph to another graph (duplicate a graph). The
-  /// simplest way of using it is through the \c graphCopy() function.
-  ///
-  /// This class not only make a copy of a graph, but it can create
+  /// simplest way of using it is through the \c copyGraph() function.
+  ///
+  /// This class not just make a copy of a graph, but it can create
   /// references and cross references between the nodes, edges and arcs of
-  /// the two graphs, and it can copy maps for using with the newly created
-  /// graph.
+  /// the two graphs, it can copy maps for use with the newly created
+  /// graph and copy nodes, edges and arcs.
   ///
   /// To make a copy from a graph, first an instance of GraphCopy
@@ -672,23 +660,23 @@
   /// The next code copies a graph with several data:
   ///\code
-  ///  GraphCopy<OrigGraph, NewGraph> cg(orig_graph, new_graph);
-  ///  // Create references for the nodes
+  ///  GraphCopy<NewGraph, OrigGraph> dc(new_graph, orig_graph);
+  ///  // create a reference for the nodes
   ///  OrigGraph::NodeMap<NewGraph::Node> nr(orig_graph);
-  ///  cg.nodeRef(nr);
-  ///  // Create cross references (inverse) for the edges
-  ///  NewGraph::EdgeMap<OrigGraph::Edge> ecr(new_graph);
-  ///  cg.edgeCrossRef(ecr);
-  ///  // Copy an edge map
-  ///  OrigGraph::EdgeMap<double> oemap(orig_graph);
-  ///  NewGraph::EdgeMap<double> nemap(new_graph);
-  ///  cg.edgeMap(oemap, nemap);
-  ///  // Copy a node
+  ///  dc.nodeRef(nr);
+  ///  // create a cross reference (inverse) for the edges
+  ///  NewGraph::EdgeMap<OrigGraph::Arc> ecr(new_graph);
+  ///  dc.edgeCrossRef(ecr);
+  ///  // copy an arc map
+  ///  OrigGraph::ArcMap<double> oamap(orig_graph);
+  ///  NewGraph::ArcMap<double> namap(new_graph);
+  ///  dc.arcMap(namap, oamap);
+  ///  // copy a node
   ///  OrigGraph::Node on;
   ///  NewGraph::Node nn;
-  ///  cg.node(on, nn);
-  ///  // Execute copying
-  ///  cg.run();
+  ///  dc.node(nn, on);
+  ///  // Executions of copy
+  ///  dc.run();
   ///\endcode
-  template <typename From, typename To>
+  template <typename To, typename From>
   class GraphCopy {
   private:
@@ -709,7 +697,7 @@
 
     struct ArcRefMap {
-      ArcRefMap(const From& from, const To& to,
+      ArcRefMap(const To& to, const From& from,
                 const EdgeRefMap& edge_ref, const NodeRefMap& node_ref)
-        : _from(from), _to(to),
+        : _to(to), _from(from),
           _edge_ref(edge_ref), _node_ref(node_ref) {}
 
@@ -725,22 +713,24 @@
       }
 
+      const To& _to;
       const From& _from;
-      const To& _to;
       const EdgeRefMap& _edge_ref;
       const NodeRefMap& _node_ref;
     };
 
+
   public:
 
-    /// \brief Constructor of GraphCopy.
-    ///
-    /// Constructor of GraphCopy for copying the content of the
-    /// \c from graph into the \c to graph.
-    GraphCopy(const From& from, To& to)
+
+    /// \brief Constructor for the GraphCopy.
+    ///
+    /// It copies the content of the \c _from graph into the
+    /// \c _to graph.
+    GraphCopy(To& to, const From& from)
       : _from(from), _to(to) {}
 
-    /// \brief Destructor of GraphCopy
-    ///
-    /// Destructor of GraphCopy.
+    /// \brief Destructor of the GraphCopy
+    ///
+    /// Destructor of the GraphCopy
     ~GraphCopy() {
       for (int i = 0; i < int(_node_maps.size()); ++i) {
@@ -753,12 +743,10 @@
         delete _edge_maps[i];
       }
-    }
-
-    /// \brief Copy the node references into the given map.
-    ///
-    /// This function copies the node references into the given map.
-    /// The parameter should be a map, whose key type is the Node type of
-    /// the source graph, while the value type is the Node type of the
-    /// destination graph.
+
+    }
+
+    /// \brief Copies the node references into the given map.
+    ///
+    /// Copies the node references into the given map.
     template <typename NodeRef>
     GraphCopy& nodeRef(NodeRef& map) {
@@ -768,10 +756,8 @@
     }
 
-    /// \brief Copy the node cross references into the given map.
-    ///
-    /// This function copies the node cross references (reverse references)
-    /// into the given map. The parameter should be a map, whose key type
-    /// is the Node type of the destination graph, while the value type is
-    /// the Node type of the source graph.
+    /// \brief Copies the node cross references into the given map.
+    ///
+    ///  Copies the node cross references (reverse references) into
+    ///  the given map.
     template <typename NodeCrossRef>
     GraphCopy& nodeCrossRef(NodeCrossRef& map) {
@@ -781,15 +767,14 @@
     }
 
-    /// \brief Make a copy of the given node map.
-    ///
-    /// This function makes a copy of the given node map for the newly
-    /// created graph.
-    /// The key type of the new map \c tmap should be the Node type of the
-    /// destination graph, and the key type of the original map \c map
-    /// should be the Node type of the source graph.
-    template <typename FromMap, typename ToMap>
-    GraphCopy& nodeMap(const FromMap& map, ToMap& tmap) {
+    /// \brief Make copy of the given map.
+    ///
+    /// Makes copy of the given map for the newly created graph.
+    /// The new map's key type is the to graph's node type,
+    /// and the copied map's key type is the from graph's node
+    /// type.
+    template <typename ToMap, typename FromMap>
+    GraphCopy& nodeMap(ToMap& tmap, const FromMap& map) {
       _node_maps.push_back(new _core_bits::MapCopy<From, Node,
-                           NodeRefMap, FromMap, ToMap>(map, tmap));
+                           NodeRefMap, ToMap, FromMap>(tmap, map));
       return *this;
     }
@@ -797,17 +782,14 @@
     /// \brief Make a copy of the given node.
     ///
-    /// This function makes a copy of the given node.
-    GraphCopy& node(const Node& node, TNode& tnode) {
+    /// Make a copy of the given node.
+    GraphCopy& node(TNode& tnode, const Node& snode) {
       _node_maps.push_back(new _core_bits::ItemCopy<From, Node,
-                           NodeRefMap, TNode>(node, tnode));
-      return *this;
-    }
-
-    /// \brief Copy the arc references into the given map.
-    ///
-    /// This function copies the arc references into the given map.
-    /// The parameter should be a map, whose key type is the Arc type of
-    /// the source graph, while the value type is the Arc type of the
-    /// destination graph.
+                           NodeRefMap, TNode>(tnode, snode));
+      return *this;
+    }
+
+    /// \brief Copies the arc references into the given map.
+    ///
+    /// Copies the arc references into the given map.
     template <typename ArcRef>
     GraphCopy& arcRef(ArcRef& map) {
@@ -817,10 +799,8 @@
     }
 
-    /// \brief Copy the arc cross references into the given map.
-    ///
-    /// This function copies the arc cross references (reverse references)
-    /// into the given map. The parameter should be a map, whose key type
-    /// is the Arc type of the destination graph, while the value type is
-    /// the Arc type of the source graph.
+    /// \brief Copies the arc cross references into the given map.
+    ///
+    ///  Copies the arc cross references (reverse references) into
+    ///  the given map.
     template <typename ArcCrossRef>
     GraphCopy& arcCrossRef(ArcCrossRef& map) {
@@ -830,15 +810,14 @@
     }
 
-    /// \brief Make a copy of the given arc map.
-    ///
-    /// This function makes a copy of the given arc map for the newly
-    /// created graph.
-    /// The key type of the new map \c tmap should be the Arc type of the
-    /// destination graph, and the key type of the original map \c map
-    /// should be the Arc type of the source graph.
-    template <typename FromMap, typename ToMap>
-    GraphCopy& arcMap(const FromMap& map, ToMap& tmap) {
+    /// \brief Make copy of the given map.
+    ///
+    /// Makes copy of the given map for the newly created graph.
+    /// The new map's key type is the to graph's arc type,
+    /// and the copied map's key type is the from graph's arc
+    /// type.
+    template <typename ToMap, typename FromMap>
+    GraphCopy& arcMap(ToMap& tmap, const FromMap& map) {
       _arc_maps.push_back(new _core_bits::MapCopy<From, Arc,
-                          ArcRefMap, FromMap, ToMap>(map, tmap));
+                          ArcRefMap, ToMap, FromMap>(tmap, map));
       return *this;
     }
@@ -846,17 +825,14 @@
     /// \brief Make a copy of the given arc.
     ///
-    /// This function makes a copy of the given arc.
-    GraphCopy& arc(const Arc& arc, TArc& tarc) {
+    /// Make a copy of the given arc.
+    GraphCopy& arc(TArc& tarc, const Arc& sarc) {
       _arc_maps.push_back(new _core_bits::ItemCopy<From, Arc,
-                          ArcRefMap, TArc>(arc, tarc));
-      return *this;
-    }
-
-    /// \brief Copy the edge references into the given map.
-    ///
-    /// This function copies the edge references into the given map.
-    /// The parameter should be a map, whose key type is the Edge type of
-    /// the source graph, while the value type is the Edge type of the
-    /// destination graph.
+                          ArcRefMap, TArc>(tarc, sarc));
+      return *this;
+    }
+
+    /// \brief Copies the edge references into the given map.
+    ///
+    /// Copies the edge references into the given map.
     template <typename EdgeRef>
     GraphCopy& edgeRef(EdgeRef& map) {
@@ -866,10 +842,8 @@
     }
 
-    /// \brief Copy the edge cross references into the given map.
-    ///
-    /// This function copies the edge cross references (reverse references)
-    /// into the given map. The parameter should be a map, whose key type
-    /// is the Edge type of the destination graph, while the value type is
-    /// the Edge type of the source graph.
+    /// \brief Copies the edge cross references into the given map.
+    ///
+    /// Copies the edge cross references (reverse
+    /// references) into the given map.
     template <typename EdgeCrossRef>
     GraphCopy& edgeCrossRef(EdgeCrossRef& map) {
@@ -879,15 +853,14 @@
     }
 
-    /// \brief Make a copy of the given edge map.
-    ///
-    /// This function makes a copy of the given edge map for the newly
-    /// created graph.
-    /// The key type of the new map \c tmap should be the Edge type of the
-    /// destination graph, and the key type of the original map \c map
-    /// should be the Edge type of the source graph.
-    template <typename FromMap, typename ToMap>
-    GraphCopy& edgeMap(const FromMap& map, ToMap& tmap) {
+    /// \brief Make copy of the given map.
+    ///
+    /// Makes copy of the given map for the newly created graph.
+    /// The new map's key type is the to graph's edge type,
+    /// and the copied map's key type is the from graph's edge
+    /// type.
+    template <typename ToMap, typename FromMap>
+    GraphCopy& edgeMap(ToMap& tmap, const FromMap& map) {
       _edge_maps.push_back(new _core_bits::MapCopy<From, Edge,
-                           EdgeRefMap, FromMap, ToMap>(map, tmap));
+                           EdgeRefMap, ToMap, FromMap>(tmap, map));
       return *this;
     }
